package provider

import (
	. "code.hoteas.com/golang/hotime"
	. "code.hoteas.com/golang/hotime/common"
	"strings"
	"time"
	"unicode/utf8"
)

// Project 管理端项目
var Project = Proj{
	"company":  CompanyCtr,
	"declare":  DeclareCtr,
	"matters":  MattersCtr,
	"order":    OrderCtr,
	"salesman": Salesman,
	"sms":      Sms,
	"tag":      TagCtr,
	"user":     UserCtr,
	"wechat":   Wechat,
}

func strToArray(str string) Slice {
	s := Slice{}

	olds := strings.Split(str, ",")
	for _, v := range olds {
		if v != "" {
			s = append(s, v)
		}
	}
	return s
}

func arrayToStr(ars Slice) string {
	s := ","
	if ars == nil {
		return s
	}
	for k, _ := range ars {
		s = s + ars.GetString(k) + ","
	}
	return s
}

//生成随机码的6位md5
func getSn() string {
	x := Rand(8)
	return Substr(Md5(ObjToStr(int64(x)+time.Now().UnixNano()+int64(Rand(6)))), 0, 6)
}

//生成随机码的4位随机数
func getCode() string {
	//res := ""
	//for i := 0; i < 4; i++ {
	res := ObjToStr(RandX(1000, 9999))
	//}
	return res
}

// 过滤 emoji 表情
func FilterEmoji(content string) string {
	new_content := ""
	for _, value := range content {
		_, size := utf8.DecodeRuneInString(string(value))
		if size <= 3 {
			new_content += string(value)
		}
	}
	return new_content
}
